// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#ifndef PERPICONFIG_HH
#define PERPICONFIG_HH

class INSTRUCTION{
public:

  static const uint32_t MaxAccessSize=32;
  static const uint32_t NB_REG_SRC=8;
  static const uint32_t NB_REG_DST=8;
  static const bool CHECK_REG_ENABLE=true;
  static const bool CHECK_MEM_ENABLE=true;
  static const uint32_t NB_MAX_PAGES=(1<<20);
  static const uint32_t LOG_PAGE_SIZE=12;
  static const uint32_t PAGE_SIZE=(1<<LOG_PAGE_SIZE);
  static const uint32_t NB_MAX_ISSUE_CYCLES=(1<<22);
};

class PERPICONFIG: public INSTRUCTION
{
public:
};

#endif // PERPICONFIG_HH
