// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#ifndef ROUTINE_HH
#define ROUTINE_HH

#include <pin.H>
#include <perpiconfig.hh>
#include <string>
#include <iostream>
using std::ostream;

/** @class SRoutine
  @brief This class allow to build object which contain all static information about an static routine
  
  A more detail class description.
  
 */
class SRoutine
{
public:
  /*! \fn SRoutine
    \brief This class allow to build object which contain all static information about an static routine
    
    A more detail class description.
    
  */
  SRoutine();
  ~SRoutine();
  SRoutine(const char *_rtnname, const char *_img_name, bool is_exe);
  
  void dump(ostream &os);

  string rtn_name;
  string image_name;
  bool is_main_executable;
};


class Routine
{
public:
  Routine();
  Routine(SRoutine *_sins);
  
  void dump(ostream &os);

  SRoutine *sroutine;
};

#endif // ROUTINE_HH
