// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#include <register.hh>
#include <string.h>
#include <iostream>
#include <cstdlib>

/*
REG convert(){
    switch(num){
    case REG_INVALID_: return REG_INVALID;
    case REG_RDI: return RDI;
    case REG_RSI: return RSI;
    case REG_RBP: return RBP;
    case REG_RSP: return RSP;
    case REG_RBX: return RBX;
    case REG_RDX: return RDX;
    case REG_RCX: return RCX;
    case REG_RAX: return RAX;
    case REG_R8: return R8;
    case REG_R9: return R9;
    case REG_R10: return R10;
    case REG_R11: return R11;
    case REG_R12: return R12;
    case REG_R13: return R13;
    case REG_R14: return R14;
    case REG_R15: return R15;
    case REG_SEG_CS: return CS;
    case REG_SEG_SS: return SS;
    case REG_SEG_DS: return DS;
    case REG_SEG_ES: return ES;
    case REG_SEG_FS: return FS;
    case REG_SEG_GS: return GS;
    case REG_RFLAGS: return RFLAGS;
    case REG_RIP: return RIP;
    case REG_EDI: return RDI;
    case REG_ESI: return RSI;
    case REG_EBP: return RBP;
    case REG_ESP: return RSP;
    case REG_EBX: return RBX;
    case REG_EDX: return RDX;
    case REG_ECX: return RECX;
    case REG_EAX: return RAX;
    case REG_EFLAGS: return RFLAGS;
    case REG_EIP: return RIP;
    case REG_AL: return RAX;
    case REG_AH: return RAX;
    case REG_AX: return RAX;
    case REG_CL: return RCX;
    case REG_CH: return RCX;
    case REG_CX: return RCX;
    case REG_DL: return RDX;
    case REG_DH: return RDX;
    case REG_DX: return RDX;
    case REG_BL: return RBX;
    case REG_BH: return RBX;
    case REG_BX: return RBX;
    case REG_BP: return RBP;
    case REG_SI: return RSI;
    case REG_DI: return RDI;
    case REG_SP: return RSP;
    case REG_FLAGS: return RFLAGS;
    case REG_IP: return RIP;
    case REG_DIL: return RDI;
    case REG_SIL: return RSI;
    case REG_BPL: return RBP;
    case REG_SPL: return RSP;
    case REG_R8B: return R8;
    case REG_R8W: return R8;
    case REG_R8D: return R8;
    case REG_R9B: return R9;
    case REG_R9W: return R9;
    case REG_R9D: return R9;
    case REG_R10B: return R10;
    case REG_R10W: return R10;
    case REG_R10D: return R10;
    case REG_R11B: return R11;
    case REG_R11W: return R11;
    case REG_R11D: return R11;
    case REG_R12B: return R12;
    case REG_R12W: return R12;
    case REG_R12D: return R12;
    case REG_R13B: return R13;
    case REG_R13W: return R13;
    case REG_R13D: return R13;
    case REG_R14B: return R14;
    case REG_R14W: return R14;
    case REG_R14D: return R14;
    case REG_R15B: return R15;
    case REG_R15W: return R15;
    case REG_R15D: return R15;
    case REG_MM0: return MM0;
    case REG_MM1: return MM1;
    case REG_MM2: return MM2;
    case REG_MM3: return MM3;
    case REG_MM4: return MM4;
    case REG_MM5: return MM5;
    case REG_MM6: return MM6;
    case REG_MM7: return MM7;
    case REG_EMM0: return MM0;
    case REG_EMM1: return MM1;
    case REG_EMM2: return MM2;
    case REG_EMM3: return MM3;
    case REG_EMM4: return MM4;
    case REG_EMM5: return MM5;
    case REG_EMM6: return MM6;
    case REG_EMM7: return MM7;
    case REG_MXT: return MXCSR;
    case REG_XMM0: return XMM0;
    case REG_XMM1: return XMM1;
    case REG_XMM2: return XMM2;
    case REG_XMM3: return XMM3;
    case REG_XMM4: return XMM4;
    case REG_XMM5: return XMM5;
    case REG_XMM6: return XMM6;
    case REG_XMM7: return XMM7;
    case REG_XMM8: return XMM8;
    case REG_XMM9: return XMM9;
    case REG_XMM10: return XMM10;
    case REG_XMM11: return XMM11;
    case REG_XMM12: return XMM12;
    case REG_XMM13: return XMM13;
    case REG_XMM14: return XMM14;
    case REG_XMM15: return XMM15;
    case REG_YMM0: return YMM0;
    case REG_YMM1: return YMM1;
    case REG_YMM2: return YMM2;
    case REG_YMM3: return YMM3;
    case REG_YMM4: return YMM4;
    case REG_YMM5: return YMM5;
    case REG_YMM6: return YMM6;
    case REG_YMM7: return YMM7;
    case REG_YMM8: return YMM8;
    case REG_YMM9: return YMM9;
    case REG_YMM10: return YMM10;
    case REG_YMM11: return YMM11;
    case REG_YMM12: return YMM12;
    case REG_YMM13: return YMM13;
    case REG_YMM14: return YMM14;
    case REG_YMM15: return YMM15;
    case REG_ST0: return ST0;
    case REG_ST1: return ST1;
    case REG_ST2: return ST2;
    case REG_ST3: return ST3;
    case REG_ST4: return ST4;
    case REG_ST5: return ST5;
    case REG_ST6: return ST6;
    case REG_ST7: return ST7;
    case REG_MXCSR: return MXCSR;
    case REG_MXCSRMASK: return MXCSRMASK;
    case REG_FPCW: return FPCW;
    case 109: return FPCW;
    case REG_FPSW: return FPSW;
    case REG_FPTAG_FULL: return FPTAG_FULL;
    case REG_FPTAG: return FPTAG;
    case REG_FPIP_OFF: return FPIP_OFF;
    case REG_FPIP_SEL: return FPIP_SEL;
    case REG_FPOPCODE: return FPOPCODE;
    case REG_FPDP_OFF: return FPDP_OFF;
    case REG_FPDP_SEL: return FPDP_SEL;
    case REG_CR0: return CR0;
    case REG_CR1: return CR1;
    case REG_CR2: return CR2; 
    case REG_CR3: return CR3;
    case REG_CR4: return CR4;
    default: return REG_INVALID;//
    }
}
*/

VOID Register::GetRegValue(CONTEXT *ctxt, VOID *data){
  uint64_t regv, zero=0;
  uint8_t data2[16];
  FPSTATE fpstate;
  REG pinreg;
  pinreg = RegX862RegPin();
  memcpy(data,&zero,32);
  if (len>8){
    PIN_GetContextFPState(ctxt,&fpstate);
    switch (pinreg){
      case REG_ST0: memcpy(data,&fpstate.fxsave_legacy._sts[0],10); break;//mm0
      case REG_ST1: memcpy(data,&fpstate.fxsave_legacy._sts[1],10); break;//mm1
      case REG_ST2: memcpy(data,&fpstate.fxsave_legacy._sts[2],10); break;//mm2
      case REG_ST3: memcpy(data,&fpstate.fxsave_legacy._sts[3],10); break;//mm3
      case REG_ST4: memcpy(data,&fpstate.fxsave_legacy._sts[4],10); break;//mm4
      case REG_ST5: memcpy(data,&fpstate.fxsave_legacy._sts[5],10); break;//mm5
      case REG_ST6: memcpy(data,&fpstate.fxsave_legacy._sts[6],10); break;//mm6
      case REG_ST7: memcpy(data,&fpstate.fxsave_legacy._sts[7],10); break;//mm7
      case REG_YMM0: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[0],16);//ymm0
      case REG_XMM0: memcpy(data,&fpstate.fxsave_legacy._xmms[0],16); break;//xmm0
      case REG_YMM1: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[1],16);//ymm1
      case REG_XMM1: memcpy(data,&fpstate.fxsave_legacy._xmms[1],16); break;//xmm1
      case REG_YMM2: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[2],16);//ymm2
      case REG_XMM2: memcpy(data,&fpstate.fxsave_legacy._xmms[2],16); break;//xmm2
      case REG_YMM3: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[3],16);//ymm3
      case REG_XMM3: memcpy(data,&fpstate.fxsave_legacy._xmms[3],16); break;//xmm3
      case REG_YMM4: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[4],16);//ymm4
      case REG_XMM4: memcpy(data,&fpstate.fxsave_legacy._xmms[4],16); break;//xmm4
      case REG_YMM5: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[5],16);//ymm5
      case REG_XMM5: memcpy(data,&fpstate.fxsave_legacy._xmms[5],16); break;//xmm5
      case REG_YMM6: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[6],16);//ymm6
      case REG_XMM6: memcpy(data,&fpstate.fxsave_legacy._xmms[6],16); break;//xmm6
      case REG_YMM7: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[7],16);//ymm7
      case REG_XMM7: memcpy(data,&fpstate.fxsave_legacy._xmms[7],16); break;//xmm7
      case REG_YMM8: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[8],16);//ymm8
      case REG_XMM8: memcpy(data,&fpstate.fxsave_legacy._xmms[8],16); break;//xmm8
      case REG_YMM9: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[9],16);//ymm9
      case REG_XMM9: memcpy(data,&fpstate.fxsave_legacy._xmms[9],16); break;//xmm9
      case REG_YMM10: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[10],16);//ymm10
      case REG_XMM10: memcpy(data,&fpstate.fxsave_legacy._xmms[10],16); break;//xmm10
      case REG_YMM11: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[11],16);//ymm11
      case REG_XMM11: memcpy(data,&fpstate.fxsave_legacy._xmms[11],16); break;//xmm11
      case REG_YMM12: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[12],16);//ymm12
      case REG_XMM12: memcpy(data,&fpstate.fxsave_legacy._xmms[12],16); break;//xmm12
      case REG_YMM13: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[13],16);//ymm13
      case REG_XMM13: memcpy(data,&fpstate.fxsave_legacy._xmms[13],16); break;//xmm13
      case REG_YMM14: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[14],16);//ymm14
      case REG_XMM14: memcpy(data,&fpstate.fxsave_legacy._xmms[14],16); break;//xmm14
      case REG_YMM15: memcpy((uint8_t *)data+16,&fpstate._xstate._ymmUpper[15],16);//ymm15
      case REG_XMM15: memcpy(data,&fpstate.fxsave_legacy._xmms[15],16); break;//xmm15
      default: break;
    }
  }
  else {
    switch (pinreg){
      case REG_MM0: memcpy(data2,&fpstate.fxsave_legacy._sts[0],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm0
      case REG_MM1: memcpy(data2,&fpstate.fxsave_legacy._sts[1],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm1
      case REG_MM2: memcpy(data2,&fpstate.fxsave_legacy._sts[2],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm2
      case REG_MM3: memcpy(data2,&fpstate.fxsave_legacy._sts[3],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm3
      case REG_MM4: memcpy(data2,&fpstate.fxsave_legacy._sts[4],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm4
      case REG_MM5: memcpy(data2,&fpstate.fxsave_legacy._sts[5],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm5
      case REG_MM6: memcpy(data2,&fpstate.fxsave_legacy._sts[6],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm6
      case REG_MM7: memcpy(data2,&fpstate.fxsave_legacy._sts[7],10);
                    memcpy(data,&(data2[2]),8);
                    break;//mm7
      default: regv = (uint64_t)PIN_GetContextReg(ctxt,pinreg);
               memcpy(data,&regv,8);
               break;
    }
  }
}


//to convert an x86 register number (our numbering) into a string
//the "len" parameter serves to output a 16-bits matching register name
//(len==2) or an 8-bits one (len==1)
//in our numbering, these registers share the same number
//for example, register AX represents both registers "ax" and "ah"
//the reason is that the register name (AX) serves as an address
//for the register. AH and AX are assumed to share their leading byte 
const char *Register::RegX862String(){ 
    switch(num){ 
    case RAX: return "rax"; 
    case EAX: return "eax"; 
    case AX: if (len==2) return "ax"; 
    else return "ah"; 
    case AL: return "al"; 
    case RBX: return "rbx"; 
    case EBX: return "ebx"; 
    case BX: if (len==2) return "bx"; 
    else return "bh"; 
    case BL: return "bl"; 
    case RCX: return "rcx"; 
    case ECX: return "ecx"; 
    case CX: if (len==2) return "cx"; 
    else return "ch"; 
    case CL: return "cl"; 
    case RDX: return "rdx"; 
    case EDX: return "edx"; 
    case DX: if (len==2) return "dx"; 
    else return "dh"; 
    case DL: return "dl"; 
    case R8: return "r8"; 
    case R8D: return "r8d"; 
    case R8W: return "r8w"; 
    case R8B: return "r8b"; 
    case R9: return "r9"; 
    case R9D: return "r9d"; 
    case R9W: return "r9w"; 
    case R9B: return "r9b"; 
    case R10: return "r10"; 
    case R10D: return "r10d"; 
    case R10W: return "r10w"; 
    case R10B: return "r10b"; 
    case R11: return "r11"; 
    case R11D: return "r11d"; 
    case R11W: return "r11w"; 
    case R11B: return "r11b"; 
    case R12: return "r12"; 
    case R12D: return "r12d"; 
    case R12W: return "r12w"; 
    case R12B: return "r12b"; 
    case R13: return "r13"; 
    case R13D: return "r13d"; 
    case R13W: return "r13w"; 
    case R13B: return "r13b"; 
    case R14: return "r14"; 
    case R14D: return "r14d"; 
    case R14W: return "r14w"; 
    case R14B: return "r14b"; 
    case R15: return "r15"; 
    case R15D: return "r15d"; 
    case R15W: return "r15w"; 
    case R15B: return "r15b"; 
    case RBP: return "rbp"; 
    case EBP: return "ebp"; 
    case BP: return "bp"; 
    case BPL: return "bpl"; 
    case RSI: return "rsi"; 
    case ESI: return "esi"; 
    case SI: return "si"; 
    case SIL: return "sil"; 
    case RDI: return "rdi"; 
    case EDI: return "edi"; 
    case DI: return "di"; 
    case DIL: return "dil"; 
    case RSP: return "rsp"; 
    case ESP: return "esp"; 
    case SP: return "sp"; 
    case SPL: return "spl"; 
    case CS: return "cs"; 
    case SS: return "ss"; 
    case DS: return "ds"; 
    case ES: return "es"; 
    case FS: return "fs"; 
    case GS: return "gs"; 
    case RFLAGS: return "rflags"; 
    case RIP: return "rip"; 
    case MM0: if (len==8) return "mm0"; 
    else return "st(0)";
    case MM1: if (len==8) return "mm1"; 
    else return "st(1)";
    case MM2: if (len==8) return "mm2"; 
    else return "st(2)";
    case MM3: if (len==8) return "mm3"; 
    else return "st(3)";
    case MM4: if (len==8) return "mm4"; 
    else return "st(4)";
    case MM5: if (len==8) return "mm5"; 
    else return "st(5)";
    case MM6: if (len==8) return "mm6"; 
    else return "st(6)";
    case MM7: if (len==8) return "mm7";
    else return "st(7)";
    case XMM0: if (len==16) return "xmm0"; 
    else return "ymm0";
    case XMM1: if (len==16) return "xmm1"; 
    else return "ymm1";
    case XMM2: if (len==16) return "xmm2"; 
    else return "ymm2";
    case XMM3: if (len==16) return "xmm3";
    else return "ymm3"; 
    case XMM4: if (len==16) return "xmm4"; 
    else return "ymm4";
    case XMM5: if (len==16) return "xmm5"; 
    else return "ymm5";
    case XMM6: if (len==16) return "xmm6"; 
    else return "ymm6";
    case XMM7: if (len==16) return "xmm7"; 
    else return "ymm7";
    case XMM8: if (len==16) return "xmm8"; 
    else return "ymm8";
    case XMM9: if (len==16) return "xmm9"; 
    else return "ymm9";
    case XMM10: if (len==16) return "xmm10"; 
    else return "ymm10";
    case XMM11: if (len==16) return "xmm11"; 
    else return "ymm11";
    case XMM12: if (len==16) return "xmm12"; 
    else return "ymm12";
    case XMM13: if (len==16) return "xmm13"; 
    else return "ymm13";
    case XMM14: if (len==16) return "xmm14"; 
    else return "ymm14";
    case XMM15: if (len==16) return "xmm15"; 
    else return "ymm15";
    case MXCSR: return "mxcsr"; 
    case MXCSRMASK: return "mxcsrmask"; 
    case FPCW: return "fpcw"; 
    case FPSW: return "fpsw"; 
    case FPTAG_FULL: return "fptag_full"; 
    case FPTAG: return "fptag"; 
    case FPIP_OFF: return "fpip_off"; 
    case FPIP_SEL: return "fpip_sel"; 
    case FPOPCODE: return "fpopcode"; 
    case FPDP_OFF: return "fpdp_off"; 
    case FPDP_SEL: return "fpdp_sel"; 
    case CR0: return "cr0"; 
    case CR1: return "cr1"; 
    case CR2: return "cr2"; 
    case CR3: return "cr3"; 
    case CR4: return "cr4"; 
    default: return "unknown"; 
    } 
} 

//to convert from our numbering to PIN numbering
REG Register::RegX862RegPin(){
     switch(num){ 
     case RAX: 
     case EAX:  
     case AX: 
     case AL:  
 #if defined(TARGET_IA32E) 
               return REG_RAX; 
 #else 
               return REG_EAX; 
 #endif 
     case RBX:  
     case EBX:  
     case BX:  
     case BL:  
 #if defined(TARGET_IA32E) 
               return REG_RBX; 
 #else 
               return REG_EBX; 
 #endif 
     case RCX: 
     case ECX:  
     case CX:  
     case CL:  
 #if defined(TARGET_IA32E) 
               return REG_RCX; 
 #else 
               return REG_ECX; 
 #endif 
     case RDX:  
     case EDX: 
     case DX:  
     case DL:  
 #if defined(TARGET_IA32E) 
               return REG_RDX; 
 #else 
               return REG_EDX; 
 #endif 
 #if defined(TARGET_IA32E) 
     case R8:  
     case R8D:  
     case R8W:  
     case R8B:  
               return REG_R8; 
     case R9:  
     case R9D: 
     case R9W:  
     case R9B:  
               return REG_R9; 
     case R10:  
     case R10D:  
     case R10W:  
     case R10B:  
               return REG_R10; 
     case R11:  
     case R11D:  
     case R11W:  
     case R11B:  
               return REG_R11; 
     case R12:  
     case R12D:  
     case R12W:  
     case R12B:  
               return REG_R12; 
     case R13:  
     case R13D:  
     case R13W: 
     case R13B:  
               return REG_R13; 
     case R14:  
     case R14D:  
     case R14W:  
     case R14B:  
               return REG_R14; 
     case R15:  
     case R15D:  
     case R15W:  
     case R15B:  
               return REG_R15; 
 #endif 
     case RBP: 
     case EBP:  
     case BP:  
     case BPL:  
 #if defined(TARGET_IA32E) 
               return REG_RBP; 
 #else 
               return REG_EBP; 
 #endif 
     case RSI:  
     case ESI:  
     case SI:  
     case SIL:  
 #if defined(TARGET_IA32E) 
               return REG_RSI; 
 #else 
               return REG_ESI; 
 #endif 
     case RDI:  
     case EDI:  
     case DI:  
     case DIL:  
 #if defined(TARGET_IA32E) 
               return REG_RDI; 
 #else 
               return REG_EDI; 
 #endif 
     case RSP:  
     case ESP:  
     case SP:  
     case SPL:  
 #if defined(TARGET_IA32E) 
               return REG_RSP; 
 #else 
               return REG_ESP; 
 #endif 
     case CS: return REG_SEG_CS; 
     case SS: return REG_SEG_SS; 
     case DS: return REG_SEG_DS; 
     case ES: return REG_SEG_ES; 
     case FS: return REG_SEG_FS; 
     case GS: return REG_SEG_GS; 
     case RFLAGS:  
 #if defined(TARGET_IA32E) 
               return REG_RFLAGS; 
 #else 
               return REG_EFLAGS; 
 #endif 
     case RIP:  
 #if defined(TARGET_IA32E) 
               return REG_RIP; 
 #else 
               return REG_EIP; 
 #endif 
     case MM0: return REG_MM0; 
     case MM1: return REG_MM1; 
     case MM2: return REG_MM2; 
     case MM3: return REG_MM3; 
     case MM4: return REG_MM4; 
     case MM5: return REG_MM5; 
     case MM6: return REG_MM6; 
     case MM7: return REG_MM7; 
     case ST0: return REG_ST0; 
     case ST1: return REG_ST1; 
     case ST2: return REG_ST2; 
     case ST3: return REG_ST3; 
     case ST4: return REG_ST4; 
     case ST5: return REG_ST5; 
     case ST6: return REG_ST6; 
     case ST7: return REG_ST7;
     case XMM0: return REG_XMM0; 
     case XMM1: return REG_XMM1; 
     case XMM2: return REG_XMM2; 
     case XMM3: return REG_XMM3; 
     case XMM4: return REG_XMM4; 
     case XMM5: return REG_XMM5; 
     case XMM6: return REG_XMM6; 
     case XMM7: return REG_XMM7; 
 #if defined(TARGET_IA32E) 
     case XMM8: return REG_XMM8; 
     case XMM9: return REG_XMM9; 
     case XMM10: return REG_XMM10; 
     case XMM11: return REG_XMM11; 
     case XMM12: return REG_XMM12; 
     case XMM13: return REG_XMM13; 
     case XMM14: return REG_XMM14; 
     case XMM15: return REG_XMM15; 
     case YMM0: return REG_YMM0; 
     case YMM1: return REG_YMM1; 
     case YMM2: return REG_YMM2; 
     case YMM3: return REG_YMM3; 
     case YMM4: return REG_YMM4; 
     case YMM5: return REG_YMM5; 
     case YMM6: return REG_YMM6; 
     case YMM7: return REG_YMM7; 
     case YMM8: return REG_YMM8; 
     case YMM9: return REG_YMM9; 
     case YMM10: return REG_YMM10; 
     case YMM11: return REG_YMM11; 
     case YMM12: return REG_YMM12; 
     case YMM13: return REG_YMM13; 
     case YMM14: return REG_YMM14; 
     case YMM15: return REG_YMM15; 
 #endif 
     case MXCSR: return REG_MXCSR; 
     case MXCSRMASK: return REG_MXCSRMASK; 
     case FPCW: return REG_FPCW; 
     case FPSW: return REG_FPSW; 
     case FPTAG_FULL: return REG_FPTAG_FULL; 
     case FPTAG: return REG_FPTAG; 
     case FPIP_OFF: return REG_FPIP_OFF; 
     case FPIP_SEL: return REG_FPIP_SEL; 
     case FPOPCODE: return REG_FPOPCODE; 
     case FPDP_OFF: return REG_FPDP_OFF; 
     case FPDP_SEL: return REG_FPDP_SEL; 
     case CR0: return REG_CR0; 
     case CR1: return REG_CR1; 
     case CR2: return REG_CR2; 
     case CR3: return REG_CR3; 
     case CR4: return REG_CR4; 
     default: return REG_INVALID_; 
     } 
 }

Register::Register()
{
  len=10000; num=10000;
}

//to convert from PIN numbering to our numbering
//the main function result is the register number in our numbering system
//the side effect result "len" is the size in bytes of the requested register
//UINT32 reg2int(REG r, UINT32 *len){
Register::Register(REG r)
{
    unsigned int reg;
    reg = (unsigned int)r;
    switch(r){
    case REG_INVALID_: len=10000; num=10000; break;
#if defined(TARGET_IA32E)
    case REG_RDI: len=8; num=RDI; break;//rdi
    case REG_RSI: len=8; num=RSI; break;//rsi
    case REG_RBP: len=8; num=RBP; break;//rbp
    case REG_RSP: len=8; num=RSP; break;//rsp
    case REG_RBX: len=8; num=RBX; break;//rbx
    case REG_RDX: len=8; num=RDX; break;//rdx
    case REG_RCX: len=8; num=RCX; break;//rcx
    case REG_RAX: len=8; num=RAX; break;//rax
    case REG_R8: len=8; num=R8; break;//r8
    case REG_R9: len=8; num=R9; break;//r9
    case REG_R10: len=8; num=R10; break;//r10
    case REG_R11: len=8; num=R11; break;//r11
    case REG_R12: len=8; num=R12; break;//r12
    case REG_R13: len=8; num=R13; break;//r13
    case REG_R14: len=8; num=R14; break;//r14
    case REG_R15: len=8; num=R15; break;//r15
    case REG_SEG_CS: len=2; num=CS; break;//cs
    case REG_SEG_SS: len=2; num=SS; break;//ss
    case REG_SEG_DS: len=2; num=DS; break;//ds
    case REG_SEG_ES: len=2; num=ES; break;//es
    case REG_SEG_FS: len=2; num=FS; break;//fs
    case REG_SEG_GS: len=2; num=GS; break;//gs
    case REG_RFLAGS: len=8; num=RFLAGS; break;//rflags
    case REG_RIP: len=8; num=RIP; break;//rip
#else
    case REG_EDI: len=4; num=EDI; break;//edi
    case REG_ESI: len=4; num=ESI; break;//esi
    case REG_EBP: len=4; num=EBP; break;//ebp
    case REG_ESP: len=4; num=ESP; break;//esp
    case REG_EBX: len=4; num=EBX; break;//ebx
    case REG_EDX: len=4; num=EDX; break;//edx
    case REG_ECX: len=4; num=ECX; break;//ecx
    case REG_EAX: len=4; num=EAX; break;//eax
    case REG_SEG_CS: len=2; num=CS; break;//cs
    case REG_SEG_SS: len=2; num=SS; break;//ss
    case REG_SEG_DS: len=2; num=DS; break;//ds
    case REG_SEG_ES: len=2; num=ES; break;//es
    case REG_SEG_FS: len=2; num=FS; break;//fs
    case REG_SEG_GS: len=2; num=GS; break;//gs
    case REG_EFLAGS: len=8; num=RFLAGS; break;//rflags
    case REG_EIP: len=8; num=RIP; break;//rip      
#endif
    case REG_AL: len=1; num=AL; break;//al
    case REG_AH: len=1; num=AH; break;//ah
    case REG_AX: len=2; num=AX; break;//ax
    case REG_CL: len=1; num=CL; break;//cl
    case REG_CH: len=1; num=CH; break;//ch
    case REG_CX: len=2; num=CX; break;//cx
    case REG_DL: len=1; num=DL; break;//dl
    case REG_DH: len=1; num=DH; break;//dh
    case REG_DX: len=2; num=DX; break;//dx
    case REG_BL: len=1; num=BL; break;//bl
    case REG_BH: len=1; num=BH; break;//bh
    case REG_BX: len=2; num=BX; break;//bx
    case REG_BP: len=2; num=BP; break;//bp
    case REG_SI: len=2; num=SI; break;//si
    case REG_DI: len=2; num=DI; break;//di
    case REG_SP: len=2; num=SP; break;//sp
    case REG_FLAGS: len=8; num=RFLAGS; break;//rflags
    case REG_IP: len=8; num=RIP; break;//rip
#if defined(TARGET_IA32E)
    case REG_EDI: len=4; num=EDI; break;//edi
    case REG_DIL: len=1; num=DIL; break;//dil
    case REG_ESI: len=4; num=ESI; break;//esi
    case REG_SIL: len=1; num=SIL; break;//sil
    case REG_EBP: len=4; num=EBP; break;//ebp
    case REG_BPL: len=1; num=BPL; break;//bpl
    case REG_ESP: len=4; num=ESP; break;//esp
    case REG_SPL: len=1; num=SPL; break;//spl
    case REG_EBX: len=4; num=EBX; break;//ebx
    case REG_EDX: len=4; num=EDX; break;//edx
    case REG_ECX: len=4; num=ECX; break;//ecx
    case REG_EAX: len=4; num=EAX; break;//eax
    case REG_EFLAGS: len=8; num=RFLAGS; break;//rflags
    case REG_EIP: len=8; num=RIP; break;//rip      
    case REG_R8B: len=1; num=R8B; break;//r8b
    case REG_R8W: len=2; num=R8W; break;//r8w
    case REG_R8D: len=4; num=R8D; break;//r8d
    case REG_R9B: len=1; num=R9B; break;//r9b
    case REG_R9W: len=2; num=R9W; break;//r9w
    case REG_R9D: len=4; num=R9D; break;//r9d
    case REG_R10B: len=1; num=R10B; break;//r10b
    case REG_R10W: len=2; num=R10W; break;//r10w
    case REG_R10D: len=4; num=R10D; break;//r10d
    case REG_R11B: len=1; num=R11B; break;//r11b
    case REG_R11W: len=2; num=R11W; break;//r11w
    case REG_R11D: len=4; num=R11D; break;//r11d
    case REG_R12B: len=1; num=R12B; break;//r12b
    case REG_R12W: len=2; num=R12W; break;//r12w
    case REG_R12D: len=4; num=R12D; break;//r12d
    case REG_R13B: len=1; num=R13B; break;//r13b
    case REG_R13W: len=2; num=R13W; break;//r13w
    case REG_R13D: len=4; num=R13D; break;//r13d
    case REG_R14B: len=1; num=R14B; break;//r14b
    case REG_R14W: len=2; num=R14W; break;//r14w
    case REG_R14D: len=4; num=R14D; break;//r14d
    case REG_R15B: len=1; num=R15B; break;//r15b
    case REG_R15W: len=2; num=R15W; break;//r15w
    case REG_R15D: len=4; num=R15D; break;//r15d
#endif
    case REG_MM0: len=8; num=MM0; break;//mm0
    case REG_MM1: len=8; num=MM1; break;//mm1
    case REG_MM2: len=8; num=MM2; break;//mm2
    case REG_MM3: len=8; num=MM3; break;//mm3
    case REG_MM4: len=8; num=MM4; break;//mm4
    case REG_MM5: len=8; num=MM5; break;//mm5
    case REG_MM6: len=8; num=MM6; break;//mm6
    case REG_MM7: len=8; num=MM7; break;//mm7
    case REG_EMM0: len=8; num=MM0; break;//mm0
    case REG_EMM1: len=8; num=MM1; break;//mm1
    case REG_EMM2: len=8; num=MM2; break;//mm2
    case REG_EMM3: len=8; num=MM3; break;//mm3
    case REG_EMM4: len=8; num=MM4; break;//mm4
    case REG_EMM5: len=8; num=MM5; break;//mm5
    case REG_EMM6: len=8; num=MM6; break;//mm6
    case REG_EMM7: len=8; num=MM7; break;//mm7
    case REG_MXT: len=4; num=MXCSR; break;//mxcsr

    case REG_XMM0: len=16; num=XMM0; break;//xmm0
    case REG_XMM1: len=16; num=XMM1; break;//xmm1
    case REG_XMM2: len=16; num=XMM2; break;//xmm2
    case REG_XMM3: len=16; num=XMM3; break;//xmm3
    case REG_XMM4: len=16; num=XMM4; break;//xmm4
    case REG_XMM5: len=16; num=XMM5; break;//xmm5
    case REG_XMM6: len=16; num=XMM6; break;//xmm6
    case REG_XMM7: len=16; num=XMM7; break;//xmm7
 
#if defined(TARGET_IA32E)
    case REG_XMM8: len=16; num=XMM8; break;//xmm8
    case REG_XMM9: len=16; num=XMM9; break;//xmm9
    case REG_XMM10: len=16; num=XMM10; break;//xmm10
    case REG_XMM11: len=16; num=XMM11; break;//xmm11
    case REG_XMM12: len=16; num=XMM12; break;//xmm12
    case REG_XMM13: len=16; num=XMM13; break;//xmm13
    case REG_XMM14: len=16; num=XMM14; break;//xmm14
    case REG_XMM15: len=16; num=XMM15; break;//xmm15
#endif
    case REG_YMM0: len=32; num=YMM0; break;//ymm0
    case REG_YMM1: len=32; num=YMM1; break;//ymm0
    case REG_YMM2: len=32; num=YMM2; break;//ymm0
    case REG_YMM3: len=32; num=YMM3; break;//ymm0
    case REG_YMM4: len=32; num=YMM4; break;//ymm0
    case REG_YMM5: len=32; num=YMM5; break;//ymm0
    case REG_YMM6: len=32; num=YMM6; break;//ymm0
    case REG_YMM7: len=32; num=YMM7; break;//ymm0
#if defined(TARGET_IA32E)
    case REG_YMM8: len=32; num=YMM8; break;//ymm0
    case REG_YMM9: len=32; num=YMM9; break;//ymm0
    case REG_YMM10: len=32; num=YMM10; break;//ymm0
    case REG_YMM11: len=32; num=YMM11; break;//ymm0
    case REG_YMM12: len=32; num=YMM12; break;//ymm0
    case REG_YMM13: len=32; num=YMM13; break;//ymm0
    case REG_YMM14: len=32; num=YMM14; break;//ymm0
    case REG_YMM15: len=32; num=YMM15; break;//ymm0
#endif
    case REG_ST0: len=10; num=ST0; break;//st(0)
    case REG_ST1: len=10; num=ST1; break;//st(1)
    case REG_ST2: len=10; num=ST2; break;//st(2)
    case REG_ST3: len=10; num=ST3; break;//st(3)
    case REG_ST4: len=10; num=ST4; break;//st(4)
    case REG_ST5: len=10; num=ST5; break;//st(5)
    case REG_ST6: len=10; num=ST6; break;//st(6)
    case REG_ST7: len=10; num=ST7; break;//st(7)
    case REG_MXCSR: len=4; num=MXCSR; break;
    case REG_MXCSRMASK: len=4; num=MXCSRMASK; break;

    case REG_FPCW: len=2; num=FPCW; break;
    case 109: len=2; num=FPCW; break;
    case REG_FPSW: len=2; num=FPSW; break;
    case REG_FPTAG_FULL: len=2; num=FPTAG_FULL; break;
    case REG_FPTAG: len=2; num=FPTAG; break;
    case REG_FPIP_OFF: len=8; num=FPIP_OFF; break;
    case REG_FPIP_SEL: len=4; num=FPIP_SEL; break;
    case REG_FPOPCODE: len=2; num=FPOPCODE; break;
    case REG_FPDP_OFF: len=8; num=FPDP_OFF; break;
    case REG_FPDP_SEL: len=4; num=FPDP_SEL; break;
    case REG_CR0: len=4; num=CR0; break;
    case REG_CR1: len=4; num=CR1; break;
    case REG_CR2: len=4; num=CR2; break;
    case REG_CR3: len=4; num=CR3; break;
    case REG_CR4: len=4; num=CR4; break;
    default: len=10000+reg; num=10000+reg; abort();//
    }
  }

/* void dump_pin_reg_map(){ */
/*  cerr << "REG_INVALID_" << REG_INVALID_ << endl; */
/*  cerr << "REG_GR_BASE" << REG_GR_BASE << endl; */
/*  cerr << "REG_RBASE" << REG_RBASE << endl; */
/* // cerr << "REG_GBASE" << REG_GBASE << endl; */
/*  cerr << "REG_EDI" << REG_EDI << endl; */
/*  cerr << "REG_GDI" << REG_GDI << endl; */
/*  cerr << "REG_ESI" << REG_ESI << endl; */
/*  cerr << "REG_GSI" << REG_GSI << endl; */
/*  cerr << "REG_EBP" << REG_EBP << endl; */
/*  cerr << "REG_GBP" << REG_GBP << endl; */
/*  cerr << "REG_ESP" << REG_ESP << endl; */
/*  cerr << "REG_STACK_PTR" << REG_STACK_PTR << endl; */
/*  cerr << "REG_EBX" << REG_EBX << endl; */
/*  cerr << "REG_GBX" << REG_GBX << endl; */
/*  cerr << "REG_EDX" << REG_EDX << endl; */
/*  cerr << "REG_GDX" << REG_GDX << endl; */
/*  cerr << "REG_ECX" << REG_ECX << endl; */
/*  cerr << "REG_GCX" << REG_GCX << endl; */
/*  cerr << "REG_EAX" << REG_EAX << endl; */
/*  cerr << "REG_GAX" << REG_GAX << endl; */
/*  cerr << "REG_GR_LAST" << REG_GR_LAST << endl; */
/* // cerr << "REG_GROT_LAST" << REG_GROT_LAST << endl; */
/*  cerr << "REG_SEG_BASE" << REG_SEG_BASE << endl; */
/*  cerr << "REG_SEG_CS" << REG_SEG_CS << endl; */
/*  cerr << "REG_SEG_SS" << REG_SEG_SS << endl; */
/*  cerr << "REG_SEG_DS" << REG_SEG_DS << endl; */
/*  cerr << "REG_SEG_ES" << REG_SEG_ES << endl; */
/*  cerr << "REG_SEG_FS" << REG_SEG_FS << endl; */
/*  cerr << "REG_SEG_GS" << REG_SEG_GS << endl; */
/*  cerr << "REG_SEG_LAST" << REG_SEG_LAST << endl; */
/*  cerr << "REG_EFLAGS" << REG_EFLAGS << endl; */
/*  cerr << "REG_GFLAGS" << REG_GFLAGS << endl; */
/*  cerr << "REG_EIP" << REG_EIP << endl; */
/*  cerr << "REG_INST_PTR" << REG_INST_PTR << endl; */
/*  cerr << "REG_AL" << REG_AL << endl; */
/*  cerr << "REG_AH" << REG_AH << endl; */
/*  cerr << "REG_AX" << REG_AX << endl; */
/*  cerr << "REG_CL" << REG_CL << endl; */
/*  cerr << "REG_CH" << REG_CH << endl; */
/*  cerr << "REG_CX" << REG_CX << endl; */
/*  cerr << "REG_DL" << REG_DL << endl; */
/*  cerr << "REG_DH" << REG_DH << endl; */
/*  cerr << "REG_DX" << REG_DX << endl; */
/*  cerr << "REG_BL" << REG_BL << endl; */
/*  cerr << "REG_BH" << REG_BH << endl; */
/*  cerr << "REG_BX" << REG_BX << endl; */
/*  cerr << "REG_BP" << REG_BP << endl; */
/*  cerr << "REG_SI" << REG_SI << endl; */
/*  cerr << "REG_DI" << REG_DI << endl; */
/*  cerr << "REG_SP" << REG_SP << endl; */
/*  cerr << "REG_FLAGS" << REG_FLAGS << endl; */
/*  cerr << "REG_IP" << REG_IP << endl; */
/*  cerr << "REG_MM_BASE" << REG_MM_BASE << endl; */
/*  cerr << "REG_MM0" << REG_MM0 << endl; */
/*  cerr << "REG_MM1" << REG_MM1 << endl; */
/*  cerr << "REG_MM2" << REG_MM2 << endl; */
/*  cerr << "REG_MM3" << REG_MM3 << endl; */
/*  cerr << "REG_MM4" << REG_MM4 << endl; */
/*  cerr << "REG_MM5" << REG_MM5 << endl; */
/*  cerr << "REG_MM6" << REG_MM6 << endl; */
/*  cerr << "REG_MM7" << REG_MM7 << endl; */
/*  cerr << "REG_MM_LAST" << REG_MM_LAST << endl; */
/*  cerr << "REG_EMM_BASE" << REG_EMM_BASE << endl; */
/*  cerr << "REG_EMM0" << REG_EMM0 << endl; */
/*  cerr << "REG_EMM1" << REG_EMM1 << endl; */
/*  cerr << "REG_EMM2" << REG_EMM2 << endl; */
/*  cerr << "REG_EMM3" << REG_EMM3 << endl; */
/*  cerr << "REG_EMM4" << REG_EMM4 << endl; */
/*  cerr << "REG_EMM5" << REG_EMM5 << endl; */
/*  cerr << "REG_EMM6" << REG_EMM6 << endl; */
/*  cerr << "REG_EMM7" << REG_EMM7 << endl; */
/*  cerr << "REG_EMM_LAST" << REG_EMM_LAST << endl; */
/*  cerr << "REG_MXT" << REG_MXT << endl; */
/*  cerr << "REG_XMM_BASE" << REG_XMM_BASE << endl; */
/*  cerr << "REG_FIRST_FP_REG" << REG_FIRST_FP_REG << endl; */
/*  cerr << "REG_XMM0" << REG_XMM0 << endl; */
/*  cerr << "REG_XMM1" << REG_XMM1 << endl; */
/*  cerr << "REG_XMM2" << REG_XMM2 << endl; */
/*  cerr << "REG_XMM3" << REG_XMM3 << endl; */
/*  cerr << "REG_XMM4" << REG_XMM4 << endl; */
/*  cerr << "REG_XMM5" << REG_XMM5 << endl; */
/*  cerr << "REG_XMM6" << REG_XMM6 << endl; */
/*  cerr << "REG_XMM7" << REG_XMM7 << endl; */
/* #if defined(TARGET_IA32E) */
/*  cerr << "REG_XMM8" << REG_XMM8 << endl; */
/*  cerr << "REG_XMM9" << REG_XMM9 << endl; */
/*  cerr << "REG_XMM10" << REG_XMM10 << endl; */
/*  cerr << "REG_XMM11" << REG_XMM11 << endl; */
/*  cerr << "REG_XMM12" << REG_XMM12 << endl; */
/*  cerr << "REG_XMM13" << REG_XMM13 << endl; */
/*  cerr << "REG_XMM14" << REG_XMM14 << endl; */
/*  cerr << "REG_XMM15" << REG_XMM15 << endl; */
/*  cerr << "REG_XMM_LAST" << REG_XMM_LAST << endl; */
/*  cerr << "REG_YMM_BASE" << REG_YMM_BASE << endl; */
/*  cerr << "REG_YMM0" << REG_YMM0 << endl; */
/*  cerr << "REG_YMM1" << REG_YMM1 << endl; */
/*  cerr << "REG_YMM2" << REG_YMM2 << endl; */
/*  cerr << "REG_YMM3" << REG_YMM3 << endl; */
/*  cerr << "REG_YMM4" << REG_YMM4 << endl; */
/*  cerr << "REG_YMM5" << REG_YMM5 << endl; */
/*  cerr << "REG_YMM6" << REG_YMM6 << endl; */
/*  cerr << "REG_YMM7" << REG_YMM7 << endl; */
/*  cerr << "REG_YMM8" << REG_YMM8 << endl; */
/*  cerr << "REG_YMM9" << REG_YMM9 << endl; */
/*  cerr << "REG_YMM10" << REG_YMM10 << endl; */
/*  cerr << "REG_YMM11" << REG_YMM11 << endl; */
/*  cerr << "REG_YMM12" << REG_YMM12 << endl; */
/*  cerr << "REG_YMM13" << REG_YMM13 << endl; */
/*  cerr << "REG_YMM14" << REG_YMM14 << endl; */
/*  cerr << "REG_YMM15" << REG_YMM15 << endl; */
/*  cerr << "REG_YMM_LAST" << REG_YMM_LAST << endl; */
/* #endif */
/*  cerr << "REG_MXCSR" << REG_MXCSR << endl; */
/*  cerr << "REG_MXCSRMASK" << REG_MXCSRMASK << endl; */
/* // cerr << "REG_ORIG_EAX" << REG_ORIG_EAX << endl; */
/*  cerr << "REG_ORIG_GAX" << REG_ORIG_GAX << endl; */
/*  cerr << "REG_DR_BASE" << REG_DR_BASE << endl; */
/*  cerr << "REG_DR0" << REG_DR0 << endl; */
/*  cerr << "REG_DR1" << REG_DR1 << endl; */
/*  cerr << "REG_DR2" << REG_DR2 << endl; */
/*  cerr << "REG_DR3" << REG_DR3 << endl; */
/*  cerr << "REG_DR4" << REG_DR4 << endl; */
/*  cerr << "REG_DR5" << REG_DR5 << endl; */
/*  cerr << "REG_DR6" << REG_DR6 << endl; */
/*  cerr << "REG_DR7" << REG_DR7 << endl; */
/*  cerr << "REG_DR_LAST" << REG_DR_LAST << endl; */
/*  cerr << "REG_CR_BASE" << REG_CR_BASE << endl; */
/*  cerr << "REG_CR0" << REG_CR0 << endl; */
/*  cerr << "REG_CR1" << REG_CR1 << endl; */
/*  cerr << "REG_CR2" << REG_CR2 << endl; */
/*  cerr << "REG_CR3" << REG_CR3 << endl; */
/*  cerr << "REG_CR4" << REG_CR4 << endl; */
/*  cerr << "REG_CR_LAST" << REG_CR_LAST << endl; */
/*  cerr << "REG_TSSR" << REG_TSSR << endl; */
/*  cerr << "REG_LDTR" << REG_LDTR << endl; */
/*  cerr << "REG_TR_BASE" << REG_TR_BASE << endl; */
/*  cerr << "REG_TR3" << REG_TR3 << endl; */
/*  cerr << "REG_TR4" << REG_TR4 << endl; */
/*  cerr << "REG_TR5" << REG_TR5 << endl; */
/*  cerr << "REG_TR6" << REG_TR6 << endl; */
/*  cerr << "REG_TR7" << REG_TR7 << endl; */
/*  cerr << "REG_TR_LAST" << REG_TR_LAST << endl; */
/*  cerr << "REG_FPST_BASE" << REG_FPST_BASE << endl; */
/*  cerr << "REG_FPSTATUS_BASE" << REG_FPSTATUS_BASE << endl; */
/*  cerr << "REG_FPCW" << REG_FPCW << endl; */
/*  cerr << "REG_FPSW" << REG_FPSW << endl; */
/*  cerr << "REG_FPTAG" << REG_FPTAG << endl; */
/*  cerr << "REG_FPIP_OFF" << REG_FPIP_OFF << endl; */
/*  cerr << "REG_FPIP_SEL" << REG_FPIP_SEL << endl; */
/*  cerr << "REG_FPOPCODE" << REG_FPOPCODE << endl; */
/*  cerr << "REG_FPDP_OFF" << REG_FPDP_OFF << endl; */
/*  cerr << "REG_FPDP_SEL" << REG_FPDP_SEL << endl; */
/*  cerr << "REG_FPSTATUS_LAST" << REG_FPSTATUS_LAST << endl; */
/*  cerr << "REG_FPTAG_FULL" << REG_FPTAG_FULL << endl; */
/*  cerr << "REG_ST_BASE" << REG_ST_BASE << endl; */
/*  cerr << "REG_ST0" << REG_ST0 << endl; */
/*  cerr << "REG_ST1" << REG_ST1 << endl; */
/*  cerr << "REG_ST2" << REG_ST2 << endl; */
/*  cerr << "REG_ST3" << REG_ST3 << endl; */
/*  cerr << "REG_ST4" << REG_ST4 << endl; */
/*  cerr << "REG_ST5" << REG_ST5 << endl; */
/*  cerr << "REG_ST6" << REG_ST6 << endl; */
/*  cerr << "REG_ST7" << REG_ST7 << endl; */
/*  cerr << "REG_ST_LAST" << REG_ST_LAST << endl; */
/*  cerr << "REG_FPST_LAST" << REG_FPST_LAST << endl; */
/*  cerr << "REG_SEG_FS_BASE" << REG_SEG_FS_BASE << endl; */
/*  cerr << "REG_SEG_GS_BASE" << REG_SEG_GS_BASE << endl; */
/*  cerr << "REG_INST_BASE" << REG_INST_BASE << endl; */
/*  cerr << "REG_INST_SCRATCH_BASE" << REG_INST_SCRATCH_BASE << endl; */
/*  cerr << "REG_INST_G0" << REG_INST_G0 << endl; */
/*  cerr << "REG_INST_G1" << REG_INST_G1 << endl; */
/*  cerr << "REG_INST_G2" << REG_INST_G2 << endl; */
/*  cerr << "REG_INST_G3" << REG_INST_G3 << endl; */
/*  cerr << "REG_INST_G4" << REG_INST_G4 << endl; */
/*  cerr << "REG_INST_G5" << REG_INST_G5 << endl; */
/*  cerr << "REG_INST_G6" << REG_INST_G6 << endl; */
/*  cerr << "REG_INST_G7" << REG_INST_G7 << endl; */
/*  cerr << "REG_INST_G8" << REG_INST_G8 << endl; */
/*  cerr << "REG_INST_G9" << REG_INST_G9 << endl; */
/*  cerr << "REG_INST_G10" << REG_INST_G10 << endl; */
/*  cerr << "REG_INST_G11" << REG_INST_G11 << endl; */
/*  cerr << "REG_INST_G12" << REG_INST_G12 << endl; */
/*  cerr << "REG_INST_G13" << REG_INST_G13 << endl; */
/*  cerr << "REG_INST_G14" << REG_INST_G14 << endl; */
/*  cerr << "REG_INST_G15" << REG_INST_G15 << endl; */
/*  cerr << "REG_INST_G16" << REG_INST_G16 << endl; */
/*  cerr << "REG_INST_G17" << REG_INST_G17 << endl; */
/*  cerr << "REG_INST_G18" << REG_INST_G18 << endl; */
/*  cerr << "REG_INST_G19" << REG_INST_G19 << endl; */
/*  cerr << "REG_INST_TOOL_LAST" << REG_INST_TOOL_LAST << endl; */
/*  cerr << "REG_BUF_BASE0" << REG_BUF_BASE0 << endl; */
/*  cerr << "REG_BUF_BASE1" << REG_BUF_BASE1 << endl; */
/*  cerr << "REG_BUF_BASE2" << REG_BUF_BASE2 << endl; */
/*  cerr << "REG_BUF_BASE3" << REG_BUF_BASE3 << endl; */
/*  cerr << "REG_BUF_BASE4" << REG_BUF_BASE4 << endl; */
/*  cerr << "REG_BUF_BASE5" << REG_BUF_BASE5 << endl; */
/*  cerr << "REG_BUF_BASE6" << REG_BUF_BASE6 << endl; */
/*  cerr << "REG_BUF_BASE7" << REG_BUF_BASE7 << endl; */
/*  cerr << "REG_BUF_BASE8" << REG_BUF_BASE8 << endl; */
/*  cerr << "REG_BUF_BASE9" << REG_BUF_BASE9 << endl; */
/*  cerr << "REG_BUF_LAST" << REG_BUF_LAST << endl; */
/*  cerr << "REG_BUF_END0" << REG_BUF_END0 << endl; */
/*  cerr << "REG_BUF_END1" << REG_BUF_END1 << endl; */
/*  cerr << "REG_BUF_END2" << REG_BUF_END2 << endl; */
/*  cerr << "REG_BUF_END3" << REG_BUF_END3 << endl; */
/*  cerr << "REG_BUF_END4" << REG_BUF_END4 << endl; */
/*  cerr << "REG_BUF_END5" << REG_BUF_END5 << endl; */
/*  cerr << "REG_BUF_END6" << REG_BUF_END6 << endl; */
/*  cerr << "REG_BUF_END7" << REG_BUF_END7 << endl; */
/*  cerr << "REG_BUF_END8" << REG_BUF_END8 << endl; */
/*  cerr << "REG_BUF_END9" << REG_BUF_END9 << endl; */
/*  cerr << "REG_BUF_ENDLAST" << REG_BUF_ENDLAST << endl; */
/*  cerr << "REG_INST_SCRATCH_LAST" << REG_INST_SCRATCH_LAST << endl; */
/*  cerr << "REG_LAST" << REG_LAST << endl; */
/* } */
