// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#ifndef _COMMON_ANALYSERS_ANALYSER_HH_
#define _COMMON_ANALYSERS_ANALYSER_HH_

#include "pin.H"
#include <vector>
#include <string>
#include <sstream>
#include <fstream>
#include <instruction.hh>
#include <routine.hh>
#include <common/cores/coreunit.hh>

using std::vector;

namespace common {
  namespace analysers{

    using common::cores::Coreunit;

template <class CONFIG>
class Analyser
{
public:
  // Analyser INTERFACE 
  Analyser();
  void do_analysis();

  void dump_analysis();
  void dump_analyser_counter();

  void startcall(SRoutine *rtn);
  void stopcall(SRoutine *rtn);

  Instruction *previous_ins;
  Instruction *current_ins;
  vector<Coreunit<CONFIG> *> cores;
  uint32_t current_call_id;
  uint32_t current_depth;

private:
  bool ctrl_start(SRoutine *rtn);
  bool ctrl_stop(SRoutine *rtn);
  
  // Check<CONFIG> check;
  // FetchUnit<CONFIG> fetchunit;
  // RenameUnit<CONFIG> renameunit;
  // IssueUnit<CONFIG> issueunit;
  // ExecuteUnit<CONFIG> executeunit;
  // MemoryUnit<CONFIG> memoryunit;
  // WritebackUnit<CONFIG> writebackunit;
  // RobUnit<CONFIG> robunit;

  // uint64_t current_fetch_cycle;
  // uint64_t current_rename_cycle;
  // uint64_t current_retire_cycle;
  // void dump_ins(Instruction *ins);

  // calltree information
  
};

  }// namespace analysers
}// namespace common

#endif // _COMMON_ANALYSERS_ANALYSER_HH_
