// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#ifndef _COMMON_CORES_MODULES_WRITEBACKUNIT_TCC_
#define _COMMON_CORES_MODULES_WRITEBACKUNIT_TCC_

#include <pin.H>
#include <instruction.hh>
#include <common/cores/modules/writebackunit.hh>

namespace common{
  namespace cores{
    namespace modules{

template <class CONFIG>
WritebackUnit<CONFIG>::WritebackUnit() 
{
}

template <class CONFIG>
uint64_t WritebackUnit<CONFIG>::writeback(Instruction *ins, uint64_t cycle) 
{
  return (cycle+CONFIG::WRITEBACK::Latency);
}

    }//    namespace modules{
  }//  namespace cores{
}// namespace common{

#endif // _COMMON_CORES_MODULES_WRITEBACKUNIT_TCC_
