// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#ifndef _COMMON_CORES_UTILS_REGISTERFILE_HH_
#define _COMMON_CORES_UTILS_REGISTERFILE_HH_

#include <pin.H>
#include <instruction.hh>
#include <vector>
namespace common{
  namespace cores{
    namespace utils{

      using std::vector;

template <class CFG>
class Rfile
{
public:
  // Registerfile INTERFACE 
//  Rfile(ADDRINT na);
   Rfile();
  ~Rfile();
  uint64_t &operator[](uint64_t i);
//private:
  //  uint64_t lrrf[CFG::RENAME::LRRFSize];
  //#ifdef ENBALE_REGISTERFILE_STACK
  uint64_t *lrrf;//[CFG::RENAME::LRRFSize];
// #else
//   uint64_t lrrf[CFG::RENAME::LRRFSize];
// #endif
/*
public:
  ADDRINT next_addr;
};

template <class CFG>
class Registerfile
{

public:
  //  typedef class CFG::RENAME RENAME;

  // Registerfile INTERFACE 
  Registerfile();
  ~Registerfile();
*/
  void push(ADDRINT na);
  void pop(ADDRINT na);
//  void dump_registers();
//  uint64_t &operator[](uint64_t i);

private:
  //  uint64_t lrrf[CFG::RENAME::LRRFSize];
//  vector<Rfile<CFG> *> rf_queue;
  typedef struct nvr {
    uint64_t retaddr;
    uint64_t rip[8];
    uint64_t rsp[8];
    uint64_t rbx[8];
    uint64_t r1215[4*8];
  } Nvr;
  vector <Nvr> rf_queue;
};

    }//    namespace utils{
  }//  namespace cores{
}// namespace common{


#endif // _COMMON_CORES_UTILS_REGISTERFILE_HH_
