// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//
#include <config.hh>

#include <iostream>
using std::ostream;


ostream &FETCH::dump(ostream &os) 
{
  os << "==============================================================================\n";
  os << "   FETCH UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "FETCH::Latency = " << Latency << "\n";
  os << "FETCH::LINESize = " << CacheLineSize << "\n";
  return os;
}


ostream &RENAME::dump(ostream &os)
{
  os << "==============================================================================\n";
  os << "   RENAME UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "RENAME::Latency = " << Latency << "\n";
  os << "RENAME::LRRFSize = " << LRRFSize << "\n";
  return os;
}

ostream &ISSUE::dump(ostream &os)
{
  os << "==============================================================================\n";
  os << "   ISSUE UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "ISSUE::Latency = " << Latency << "\n";
  return os;
}

ostream &EXECUTE::dump(ostream &os)
{
  os << "==============================================================================\n";
  os << "   EXECUTE UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "EXECUTE::Latency = " << Latency << "\n";
  return os;
}

ostream &MEMORY::dump(ostream &os) 
{
  os << "==============================================================================\n";
  os << "   MEMORY UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "MEMORY::Latency = " << Latency << "\n";
  return os;
}

ostream &WRITEBACK::dump(ostream &os)
{
  os << "==============================================================================\n";
  os << "   WRITEBACK UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "WRITEBACK::Latency = " << Latency << "\n";
  return os;
}

ostream &ROB::dump(ostream &os)
{
  os << "==============================================================================\n";
  os << "   ROB UNIT CONFIGURATION PARAMETERS\n";
  os << "==============================================================================\n";
  os << "ROB::Latency = " << Latency << "\n";
  os << "ROB::WindowSize = " << WindowSize << "\n";
  os << "ROB::RetireWidth = " << RetireWidth << "\n";
  return os;
}

ostream &CONFIG::dump(ostream &os)
{
  // switch (simulator_type){
  //   case SINGLE_CORE:
  FETCH::dump(os);
  RENAME::dump(os);
  ISSUE::dump(os);
  EXECUTE::dump(os);
  MEMORY::dump(os);
  WRITEBACK::dump(os);
  ROB::dump(os);
  // break;
  // case ILP_BASIC:
  //   os << "==============================================================================\n";
  //   os << "   BASIC ILP SIMULATOR\n";
  //   os << "==============================================================================\n";
  //   break;
  // default:
  //   break;
  // }
  return os;
}
