// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#include <ilptool-1.0.hh>

#include <common/analysers/analyser.hh>
#include <common/analysers/analyser.tcc>

#include <instrument.hh>
#include <instrument.tcc>

#include <config.hh>

// #include <coreunit.hh>
// #include <coreunit.tcc>
// template class Coreunit<CONFIG>;

using common::analysers::Analyser;

template<>
  Analyser<CONFIG>  Instrument<Analyser<CONFIG> >::ana = Analyser<CONFIG>();

template<>
  bool Instrument<Analyser<CONFIG> >::is_global_instrument_on=true;

template<>
  bool Instrument<Analyser<CONFIG> >::is_main_started=false;

template<>
  bool Instrument<Analyser<CONFIG> >::is_main_stopped=false;

template<>
  bool Instrument<Analyser<CONFIG> >::is_ret_from_main_fixed=false;

template<>
  bool Instrument<Analyser<CONFIG> >::is_fini=false;

template<>
  bool Instrument<Analyser<CONFIG> >::last_instrumented_ins_was_call=false;

template<>
  ADDRINT Instrument<Analyser<CONFIG> >::ret_from_main=0;

template<>
  ADDRINT Instrument<Analyser<CONFIG> >::last_ret_addr=0;

int main(int argc, char * argv[])
{ 
  Instrument<Analyser<CONFIG> > instrument;
  
  instrument.InitInstrument(argc, argv);

  calltree_outstream.open((Knob_CallTree_File.Value()).c_str());
  //  trace_outstream.open((Knob_Trace_File.Value()).c_str());
  calltree_outstream.imbue(std::locale("C"));

  instrument.StartInstrument(argc, argv);

  calltree_outstream.close();
  //  trace_outstream.close();

  return 0;
}

