// 
// ------------------------------------------------------------------------
// Copyright (C) 2012, 
// University of Perpignan Via Domitia, DALI.
//
//   This file is part of Perpi.
//
//   Perpi is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Perpi is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Perpi.  If not, see <http://www.gnu.org/licenses/>.
//
//   Authors: 
//       Bernard Goossens (goossens@univ-perp.fr)
//       David Parello (david.parello@univ-perp.fr)
// ------------------------------------------------------------------------
//

#ifndef _TOOLS_ILPBASE_ILPTOOL_1_0_HH_
#define _TOOLS_ILPBASE_ILPTOOL_1_0_HH_

#include <pin.H>
#include <fstream>

using std::ofstream;
//#include <common/analysers/analyser.hh>

//! \mainpage Tmce-bltm tool
//!
//! \section intro Introduction
//!
//! Tmce-bltm is a Perpitool (pintool based on Perpi library) allowing user to simulate a BaseLine Timing Model microarchitecture.
//!
//!
//!
KNOB<string> Knob_CallTree_File(KNOB_MODE_WRITEONCE,"pintool","outct","_ilptool-1.0.speculative_fork.calltree","Specify calltree file name");

KNOB<string> Knob_Config_File(KNOB_MODE_WRITEONCE,"pintool","cfg","_ilptool-1.0.speculative_fork.configuration","Specify output configuration file name");

KNOB<string> Knob_CallTree_Dump(KNOB_MODE_WRITEONCE,"pintool","dump","main","Specify calltree dump (main or all)");

KNOB<UINT32> Knob_MaxDepth_Param(KNOB_MODE_WRITEONCE,"pintool","d","-1","Specify maximum depth analysis");

KNOB<string> Knob_Trace_File(KNOB_MODE_WRITEONCE,"pintool","outtr","_ilptool-1.0.speculative_fork.trace","Specify trace file name");

KNOB<UINT32> Knob_TurnOnTrace_Param(KNOB_MODE_WRITEONCE,"pintool","t","0","Turn on trace analysis (0,1) default 0");

ofstream calltree_outstream;
//ofstream trace_outstream;


#endif //_TOOLS_ILPBASE_ILPTOOL_1_0_HH_
